/*
 *      SenSyn - Version 1.1
 *
 *      Copyright (c) 1991, 1992 by Sensimetrics Corporation
 *      Copyright (c) 1991 Massachusetts Institute of Technology
 *      All Rights Reserved.
 *
 */

/*
 *  sensyn.c
 *
 *  from klsyn88.c, coded by D. H. Klatt
 *
 *  Modification History:
 *    23 Feb 1993    version 1.1
 *
 */

#include <stdio.h>
#include <ctype.h>
#include "sensyn.h"  /* Defines all variables in capital letters */
#include "reson.h"
#include "synth.h"
#include "../main_src/diva_dir.h"

/*
#define P_F1 9
#define P_F2 13
#define P_F3 15
#define P_F4 17
*/

char date[] = {"SenSyn     Version 1.1     Sensimetrics Corporation "};

	char defaltnam[] = DEFCON;

        FILE *fopen(), *fconf, *odev, *odoc;
        int pdata[MAX_VAR_PARS][MAX_FRAMES];  /* Parameter data [np][nf] */
        char firstname[40];		/* First name of all output files */
	char dname[40];			/* .doc configuration file name */
	char wname[40];			/* .wav waveform file name */
	char pname[40];			/* .ps postscript laser plot file name */
        char string[40];		/* Temporary string buffer */
	char param[5];
        char request;
	char command;
	char sym1,sym2,sym3;
        int i,n,npar1,lastnf,lastval;
	int nsamtot,nskip;
	INT16 *iwave;
	static int warningsw,nc,samrat,nsperframe;
#ifdef COMMENT
	static int ms25,dispt;
#endif COMMENT

/*    State Variables */
        char user;      /* If == NOVICE, print everything */
        char graphout;  	/* = {VT100, VT125, VS100} */
	int plotsw;	/* Set to 1 if plot has been made on VT125 screen */
        char ipsw;      /* TRUE if default pars inserted in par tracks */
        int np;         /* Current parameter */
        int nf;         /* Current time frame */
        int val;        /* Current value of current par for cur frame */

/*    Configuration definition Arrays */
/*              First entry in config must be desired utterance dur in ms */
/*              Second entry must be the desired number of ms per frame */
/*              (from these numbers are computed NSAMP_PER_FRAME & nframes) */
        int npars;              /* Number of parameters in config definition */
	int totdur;		/* Utterance duration in msec */
	int ms_frame;		/* Number of msec in a frame */
        int nframes;            /* # frames (Dur in ms divided by framedur */
        int nvar;               /* Number of variable parameters in config */
        char symb[NPAR][4];     /* 2 or 3 char symbol for parameter */
        char cv[NPAR];  	/* Constant/variable switch for each param */
        int maxval[NPAR];       /* Maximaum values for all parameters */
        int minval[NPAR];       /* Minimum values for all parameters */
        int defval[NPAR];       /* Default values for all parameters */
	char definition[NPAR][51];	/* Text definition of each parameter */
        int dispars[NPAR];      /* Flags for other pars to be displayed (NOT USED) */
/*    Variables known to parwave.c */
        int pars[NPAR];		/* Whenever NPAR changed, change code below */
				/*  that sets f0next, and change all of the */
				/*  pars[xx] = statements in PARWAVEF.C     */
	int sigmx;

/*    Speaker Definition	    0  1  2  3  4  5  6  7  8  9 10 11 */
        int spkrdef[12];	/* du ui sr nf ss rs sb cp os gv gh gf */
/*				     (ui is in samples) */

/*	static KEYIO keyiospace; HOWITT */
	static int ttype,*ptext;
	int forfreq[10],nforfreq;	/* Formant freq estimates */
	int time_in_ms; 	/* Time in msec corresp. to cursor position */

	static char *when;
	static long tvec;

/*	extern char	toupper(); HOWITT */

	static int ngrids,tgridmax,timetrunc;
	char symdigit[5] = {'1', '2', '3', '4', '5' };
	static int batchjob;		/* Set to 1 if a batch job */

#define FALSE 0

/* HOWITT 12 February 1991   Insert my own toUpper because Sun C macro
   toupper only works if char is lowercase to start with.  Clowns.   */
char toUpper(c)
char c;
{
  if (isascii(c))
  {if (islower(c)) return toupper(c); else return c;}
  else return c;
}

extern double dBconvert(); /* HOWITT added */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*                              M A I N                                  */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

noop()
{
	int i,j;

        static  double   formants[11][4]
                = {
                   {  250, 2255, 2702, 3534 },  /* i */
                   {  315, 1940, 2520, 2955 },  /* e */
                   {  460, 1840, 2597, 3165 },  /* epsilon */
                   {  199, 1935, 2060, 2883 },  /* y */
                   {  410, 1720, 2480, 2965 },  /* phi */
                   {  246,  775, 2340, 2964 },  /* u */
                   {  452,  818, 2423, 2770 },  /* o */
                   {  650,  920, 2663, 3510 },  /* alpha */
                   {  683, 1130, 2550, 3576 },  /* a */
                   {  570, 1563, 2498, 3109 },  /* ae */
                   {  282, 1612, 2300, 2911 }   /* ubar */
                  };

	initconfig();	/* Read defaults from .con file */
	clearpar();	/* Put defaults in time functions */

	copystring("vowels.doc",dname);

	readdocfile();

	/* utter all vowels */
	for(i=0; i<11; i++) {
		defval[P_F1 + 12] = formants[i][0];
		defval[P_F2 + 12] = formants[i][1];
		defval[P_F3 + 12] = formants[i][2];
		defval[P_F4 + 12] = formants[i][3];

		synthesize();
	}

	initconfig();	/* Read defaults from .con file */

	copystring("vowels.doc",dname);

	readdocfile();

	/* utter vowel 8 at different fundamental frequencies */
	defval[P_F1 + 12] = formants[8][0];
	defval[P_F2 + 12] = formants[8][1];
	defval[P_F3 + 12] = formants[8][2];
	defval[P_F4 + 12] = formants[8][3];

	cv[P_F0 + 12] = VARRIED;
	for(i=0; i<25; i++)
		pdata[P_F0 + 12][i] = 1000+10*i;
	for(; i<50; i++)
		pdata[P_F0 + 12][i] = 1500-10*i;

	for (i=0; i<5; i++)
	synthesize();
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*      1.              R E A D - D O C - F I L E                        */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

readdocfile()   {

	int nc;

/* If there is a doc file with first name, open it and skip over beginning */
	if((fconf = fopen(dname,"r")) != NULL){
		skip_line(fconf); /* 24. Skip "synthesis spec ... " line */
		skip_line(fconf); /* Skip blank line */
		skip_line(fconf); /* Skip version number identification */
		skip_line(fconf);
		skip_line(fconf); /* Skip "Max output" line */ 
		skip_line(fconf); /* Skip "number of samples" line */
		skip_line(fconf);

	}
/*    Otherwise, abort */
	else {
		printf("\tConfiguration/parameter file '%s' does not exist, abort\n",
		 dname);
		exit(1);
	}

	/* printf("    Reading config file '%s' ...\n", dname) ; */

	readheader();		/*  2. Read default values into arrays */

/*    Check how many parameters are varied */
	nvar = 0 ;
	for(n=0; n<npars; n++) {
		if (cv[n] == VARRIED)  nvar++ ;
		if ((n < 12) && (cv[n] != FIXED)) {
		    printf(
	    "\n\nERROR: File '%s' incompatable with new SenSyn, use KLSYN\n\n",
		     dname);
		    exit(1);
		}
	}
	/* printf("\t%d parameters are time varying\n", nvar) ; */

/*    Set all params to config values */
	skip_line(fconf);	/* 24. Finish last line */

	for(np=0; np<npars; np++)
		clearpar();	/* 12. Enter default values into par time funcs */
	ipsw = SEN_TRUE ;
/*   If any parameters were varied, read rest of file and fill in values */
	if (nvar != 0) {
		skip_line(fconf);	/* 24. Skip four blank lines */
		skip_line(fconf);
		skip_line(fconf);
		skip_line(fconf);
		skip_line(fconf);	/* Skip "Varied params" line */

		/* fill in values for varied parameters */
		for(nf=0; nf<nframes; nf++)  {
		    get_digits(fconf);			/* 22. Skip time */
		    for(np=0; np<npars; np++)  {
			if(cv[np] == VARRIED) 
			    pdata[np][nf] = get_digits(fconf);	/* 22. */
		    }
		}
	}
	fclose(fconf);
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*      2.       R E A D - D E F A U L T - C O N F I G - F I L E         */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

initconfig() {

/*    Open default configuration file */
	if ((fconf = fopen(defaltnam,"r")) == NULL) {
            printf(
	    "\tSYSTEM ERROR: Default configuration file '%s' does not exist\n",
	     defaltnam);
	    exit(1);
        }
	/* printf("    Reading default config file ...\n"); */
/*    Read header of a config file into various arrays */
        readheader();		/*  2. */
        fclose(fconf);
}


readheader() {

/*	extern char toupper(); HOWITT */

        skip_line(fconf);	/* 24. */
        skip_line(fconf);	/* 24. Ignore file header "Current config" */
        npars = get_digits(fconf);    /* 22. Number of pars in config file */
        skip_line(fconf);
        skip_line(fconf);
        skip_line(fconf);
        skip_line(fconf);	/* and ignore header "SYM  V/C ..." */

        for (n=0; n<npars; n++) {
/*	  Read 2 or 3 char symbol for each synthesis parameter */
	    nc = 0;
	    symb[n][0] = get_nonwhite_char(fconf);
	    do {
		nc++;
		fscanf(fconf, "%c", &symb[n][nc]);
	    } while ((symb[n][nc] != ' ') && (symb[n][nc] != '\0')
	     && (nc < 3));
/*	  Make symbols all caps */
	    symb[n][0] = toUpper(symb[n][0]);
	    symb[n][1] = toUpper(symb[n][1]);
	    symb[n][2] = toUpper(symb[n][2]);
	    symb[n][nc] = '\0';
            cv[n] =    get_nonwhite_char(fconf);
            minval[n] = get_digits(fconf);		/* 22. */
            defval[n] = get_digits(fconf);
            maxval[n] = get_digits(fconf);
/*	  Read text description of each synthesis parameter */
	    nc = -1;
	    do {
		nc++;
		fscanf(fconf, "%c", &definition[n][nc]);
	    } while ((definition[n][nc] != '\n') && (nc < 50));
/*	  See if description is too long to be displayed on screen */
	    if (definition[n][nc] != '\n') {
		printf(
		"\nERROR: Description of parameter %s is too long, remainder is: ",
		&symb[n][0]);
		do {
		    printf("%c", definition[n][nc]);
		    fscanf(fconf, "%c", &definition[n][nc]);
		} while (definition[n][nc] != '\n');
	    }
	    definition[n][nc] = '\0';
        }
        setspdef();		/*  2. Set speaker-defining constants */
}


setspdef() {			/* Change DU, UI, or SR */


/*    Read all speaker-def constants into array in order expected by parwave.c */
	spkrdef[0] =  defval[findnp("DU")];
	spkrdef[1] =  defval[findnp("UI")];
	spkrdef[2] =  defval[findnp("SR")];
	spkrdef[3] =  defval[findnp("NF")];
	spkrdef[4] =  defval[findnp("SS")];
	spkrdef[5] =  defval[findnp("RS")];
	spkrdef[6] =  defval[findnp("SB")];
	spkrdef[7] =  defval[findnp("CP")];
	spkrdef[8] =  defval[findnp("OS")];
	spkrdef[9] =  defval[findnp("GV")];
	spkrdef[10] = defval[findnp("GH")];
	spkrdef[11] = defval[findnp("GF")];

/*    Set number of frames in utterance, and number of samples per frame */
	samrat =   defval[findnp("SR")];
	nforfreq = defval[findnp("NF")];
	totdur   = defval[findnp("DU")];
	ms_frame = defval[findnp("UI")];
/*    Redefine UI to be in samples */
        spkrdef[1] = (ms_frame * samrat) / 1000;
	nsperframe = spkrdef[1];
        nframes = (totdur + ms_frame - 1) / ms_frame;	/* Round up */
        if (nframes > MAX_FRAMES) {
            printf("\n\tToo many frames for parameter buffer,");
            printf(" MAX_FRAMES=%d frames,\n", MAX_FRAMES);
            nframes = MAX_FRAMES;
	    printf(
	 "\t  duration truncated.  (Increase 'ui' or recompile with larger\n");
	    printf(
	     "\t   MAX_FRAMES before setting 'du' greater than %d ms).\n\n",
	     nframes*ms_frame);
        }
        totdur  = nframes * ms_frame;
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*      3.                P U T - C O N F I G - F I L E                  */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


putconfig(dev) FILE *dev; {

	char symspace;

	if (dev == stdout) {
	    fprintf(dev, "\n  CURRENT CONFIGURATION:    (%2d parameters)\n",
		 npars);
	}
	else {
	    fprintf(dev, "\n  CURRENT CONFIGURATION:\n");
	    fprintf(dev, "    %2d parameters\n\n", npars);
        }
	if (dev != stdout) {
	   fprintf(dev, "  ");
	}
	fprintf(dev, "   SYM V/C  MIN   VAL   MAX  DESCRIPTION\n");
        fprintf(dev, "   ----------------------------------------------\n");
        for (n=0; n<npars; n++) {
	    if (dev == stdout) {
		fprintf(dev, "%2d. ", n+1);
	    }
	    else {
		fprintf(dev, "  ");
	    }
	    if (symb[n][2] == '\0')  symspace = ' ';
	    else symspace = symb[n][2];
            fprintf(dev, "%c%c%c  %c %4d %5d %5d %s",
              symb[n][0], symb[n][1], symspace, cv[n], minval[n],
	      defval[n], maxval[n], &definition[n][0]);
            fprintf(dev, "\n");
	    if ((n == 19) && (dev == stdout)) {
		printf(
		"\nTo see additional synthesis control parameters, press return, q to quit:");
		command = getchar();  /* HOWITT */
		if (command != '\n')    break;
	        fprintf(dev, "\n      SYM V/C  MIN   VAL   MAX  DESCRIPTION\n");
        	fprintf(dev,
		 "      ----------------------------------------------\n");
	    }
	    if ((n == 39) && (dev == stdout)) {
		printf(
		"\nTo see additional synthesis control parameters, press return, q to quit:");
		command = getchar(); /* HOWITT */
		if (command != '\n')    break;
	        fprintf(dev, "\n      SYM V/C  MIN   VAL   MAX  DESCRIPTION\n");
        	fprintf(dev,
		 "      ----------------------------------------------\n");
	    }
        }
        fprintf(dev, "\n");
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*      4.                  S E T - T Y P I C A L - P A R                */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

settypicalpar() {

	if (cv[np] == VARRIED) {
	    printf(
	    "\tThis parameter already varied, change in default has no effect\n");
	    return;
	}
	printf("\tChange value of %s (min = %d, max = %d) to\n", 
	 &symb[np][0], minval[np], maxval[np]);
	if ((val = get_value(defval[np])) >= 0) {		/* 21. */
            defval[np] = val;
	}
	clearpar();			/* 12. Put new value in time function */

	if (cv[np] == FIXED) {
	    setspdef();        /*  2. Reset speaker-defining attributes */
	}
        if ((user == NOVICE) || (val != defval[np])) {
            putconfig(stdout);		/*  3. */
        }
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*      5.                  D R A W - P A R A M E T E R                  */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

drawparam() {

	int nfsw;

        if ((graphout == VT100) && (nvar > 0)) {
            prparnames(stdout);		/* 17. Print names of varied paramters */
        }

/*    Initialize paramter buffer if not done yet */
        if (ipsw != SEN_TRUE) {
            initpars();				/* 12. */
        }

/*    Select paramter (loop here until user types 'q' or <CR> */
        while ((np = get_par_name()) >= 0) {	/* 19. */

            if (cv[np] == FIXED) {
                printf("\tERROR: %\'%s' Not a variable param",
                  &symb[np][0]);
                printf(" try again\n");
            }
            else {
                if (cv[np] != VARRIED) {
                    nvar++;
                    cv[np] = VARRIED;
                }

		if ((graphout == VT100) && (warningsw == 0)) {
		    printf(
		     "\tNo graphics capability on default VT100 terminal\n");
		    warningsw = 1;
		}

/*	      Clear screen, make grid, enable draw on VT-125 */
		begingraph();		/*  5. */

/*	      Read very first point (i.e. do not draw line from previous point */
		gettimval(&nf,&val);	/*  5. */
                if (nf >= 0) {

/*                Set switches to cause setting of value of initial point */
		    nfsw = nf;
                    lastnf = nf;
/*                Now draw a bunch of straight lines until time = <CR> */
		    while (1) {
                        lastval = val;
			gettimval(&nf,&val);	/*  5. */
			if (nf < 0) {
			    if (nfsw != -1) {	/* Set single point upon exit */
	                	pdata[np][nfsw] = lastval;
			    }
			    break;
			}

/*		      In order to graph new line segment, first erase old one */
			eraseparline();		/*  5. */

/*		      Change values in data array */
			if (nfsw != -1) {
/*			  Must wait until erase before setting first point */
	                    pdata[np][nfsw] = lastval;
			    nfsw = -1;
			}
                        draw_line();		/* 13. */
                        lastnf = nf;

/*		      Draw new line segment on graphical terminal */
			drawparline();		/*  5. */

                    }
		}
            }
        }
        if ((graphout == VT100) && (nvar > 0)) {
	    prpars(stdout);	/* 17. List values vs time for varied pars */
	}
}


/* Clear screen, draw axes, plot current param track */
begingraph() {

	if (graphout == VT125) {
	  printf("ERROR: graphics mode currently not supported\n");
	}
}


/* Obtain <time,value> from terminal */
gettimval(gtime,gvalue) int *gtime,*gvalue; {

time1:
		*gtime = get_time();		/* 20. */
                if (*gtime >= 0) {

/*                Ask for paramter value, see if legal value */
                    *gvalue = get_value( getpval());	/* 21.(15.) */
/*		  Typing a value less than -1 is request to correct time spec */
		    if (*gvalue < -1)    goto time1;
		}
}


/* Erase from plot that part of line that will be replaced by new line seg */
/* i.e. for par `np', erase nframes, starting at frame `nf' */
eraseparline() {
	if (graphout == VT125) {
	printf("ERROR: graphics mode currently not supported\n");
	}
}


/* Draw new line segment on graphical teminal */
/* i.e. for par `np', plot nframes, starting at frame `nf' */
drawparline() {
	if (graphout == VT125) {
	printf("ERROR: graphix mode currently not supported\n");
	}
}

/* Clear graphical device of any plotted material if new request received */
/*  at top level */
endgraph() {
	/*  HOWITT: do something to clear screen */
    plotsw = 0;
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     10.            S Y N T H E S I Z E - W A V E F O R M              */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

synthesize() {

	char *malloc();
	int samper;

        /* printf("\tSynthesize waveform.\n"); */

	nsamtot = nframes * nsperframe;

/*    Allocate core area to put synthetic waveform */
	if ((iwave = (INT16 *)malloc(nsamtot*2)) == NULL) {
	    printf("ERROR in sensyn.c: no room in system core for wave\n");
	    return;
	}

        if (ipsw != SEN_TRUE) {
            initpars();         /* Stick default values in param tracks */
        }


/*    Main loop, for each frame of parameter data */
	nsamtot = 0;
        for (nf=0; nf<nframes; nf++) {

/*        Move pars into output parameter buffer */
	    nskip = 0;
            for (np=0; np<npars; np++) {
		if (cv[np] == FIXED) {
		    nskip++;
		}
                else if (cv[np] == VARRIED) {
                    pars[np-nskip] = pdata[np][nf];  /* Skip FIXED pars */
                }
                else {
                    pars[np-nskip] = defval[np];
                }
/*	      Move next value of f0, f0next into last par */
		if ((symb[np][0] == 'f') && (symb[np][1] == '0')) {
	            if (cv[np] == VARRIED) {
			pars[LOC_F0INTERP] = pdata[np][nf+1];
		    }
		    else    pars[LOC_F0INTERP] = defval[np];
		}
            }


/*        Compute waveform chunk from parameter data */
            senswave(&iwave[nsamtot]);		/* in PARWAVEF.C */
	    nsamtot += nsperframe;
	}
	if (sigmx <= 0)    sigmx = 1;

/*    Save array in output file */
	samper = 1000000 / samrat;
        writWave(wname,iwave,nsamtot,samper);	/* In library WRITWAVE.C */
	free(iwave);
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     11.                   A S K - F O R - N A M E                     */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

askforname() {

        char garb;

trynam: printf("\n\tFirst name for synthesis output file");
        printf(" (9 chars max): ");
        for (n=0; n<12; n++) {
            scanf("%c", &garb);
            if (garb != '\n') {
                firstname[n] = garb;
            }
            else {
                break;
            }
        }
        firstname[n] = '\0';
	if (n == 0) {
	    printf("\n\tERROR: Name has no characters, try again\n");
	    goto trynam;
	}
	if (n > 9) {
	    firstname[9] = '\0';	/* Max # chars is 9 */
	    printf("\n\tERROR: Name too long, try again\n",
	     firstname);
	    goto trynam;
	}
        makefilenames();
}


makefilenames() {

        mergestring(firstname,".sd",wname);		/* 25. */
        mergestring(firstname,".doc",dname);
        mergestring(firstname,".ps",pname);
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     12.        I N I T - P A R A M E T E R - T R A C K S              */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

initpars() {	/* Put default value in all parameter time functions */

        ipsw = SEN_TRUE;
        nvar = 0;
        for (np=0; np<npars; np++) {
            if (cv[np] != FIXED) {
                if (cv[np] == VARRIED) {
                    cv[np] = VARIABLE;
                }
                clearpar();			/* 12. */
            }
        }
/*      printf("\n\tDefault values placed in variable param buffers\n\n"); */
}


clearpar() {	/* Put default value in parameter = np time function */

        for (nf=0; nf<nframes; nf++) {
            val = defval[np];
            setpval();			/* 16. Put value in time function */
        }
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*      13.                  D R A W - L I N E                           */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

draw_line() {

        double dval,dnf;
        int nf1,nf2,val1,nfinc;

/*    See if line to be drawn forward in time or backward */
        if (nf > lastnf) {
            nfinc = 1;
        }
        else {
            nfinc = -1;
        }

/*    Linear interpolation */
        nf1 = lastnf;
        nf2 = nf;
        val1 = lastval;
        dval = (val - lastval) * 10;
	if (dval > 0) dval += 9;
        dnf = (nf2 - nf1) * 10;
        for (nf=nf1; nf!= nf2; nf+=nfinc) {
            val = val1 + ((dval*(nf-nf1))/dnf);
            pdata[np][nf] = val;
        }
        nf = nf2;
        val = val1 + dval/10;
        pdata[np][nf] = val;
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     14.                  D E C O D E - P A R A M                      */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

int findnp(syms) char *syms; {

        int nxx;
	char *syms1;

        nxx = 0;
        for (nxx=0; nxx<npars; nxx++) {
	    syms1 = syms;
            if (*syms1++ == symb[nxx][0]) {
		if (*syms1++ == symb[nxx][1]) {
		    if (*syms1 == symb[nxx][2]) {
	                return(nxx);
		    }
		}
            }
        }
	printf(
	"\n\tERROR in findnp() of SenSyn: can't find par named '%s'\n", syms);
        return(-1);
}

decodparam() {		/* Find np corresponding to <symb[np][]> */

        int nxx;

        nxx = 0;
        for (nxx=0; nxx<npars; nxx++) {
            if ((sym1 == symb[nxx][0]) && ( sym2 == symb[nxx][1])) {
                return(nxx);
            }
        }
        return(-1);
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     15.                      G E T P V A L                            */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

getpval() {

        if (np >= MAX_VAR_PARS) {
            printf("  ERROR: np=%d > max=%d in getpval(), return 0",
              np, MAX_VAR_PARS);
            return(0);
        }
        if (nf >= MAX_FRAMES) {
            printf("  ERROR: Time frame nf=%d > max=%d in getvpar(), return 0",
              nf, MAX_FRAMES);
            return(0);
        }
	if (cv[np] != 'V')    return(defval[np]);
        return(pdata[np][nf]);
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     16.                       S E T P V A L                           */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

setpval() {	/* 16. Put val in time function np at frame nf */

        if (np > MAX_VAR_PARS) {
            printf("  ERROR: np=%d > max=%d in setpval(), ignore request\n",
              np, MAX_VAR_PARS);
        }
        else if (nf >= MAX_FRAMES) {
            printf("  ERROR: Time frame nf=%d > max=%d in setvpar(), ignored\n",
              nf, MAX_FRAMES);
        }
        else {
            pdata[np][nf] = val;
        }
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     17.         P R I N T - P A R A M E T E R - T R A C K S           */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

prpars(dev) FILE *dev; {

    if (nvar == 0) {
        fprintf(dev, "\tNo parameters are varied\n");
    }
    else {
	prparnames(dev);		/* 17. */
        for (n=0; n<nframes; n++) {
	    fprintf(dev, "%4d", ms_frame*n);
            for (npar1=0; npar1<npars; npar1++) {
                if (cv[npar1] == VARRIED) {
                    fprintf(dev, "%5d", pdata[npar1][n]);
                }
            }
            fprintf(dev, "\n");
        }
        fprintf(dev, "\n");
    }
}

prparnames(dev) FILE *dev; {

        fprintf(dev, "\n\nVaried Parameters:\n");
	if (nvar == 0) {
	    fprintf(dev, "    none");
	}
	else {
	    fprintf(dev, "time");
            for (npar1=0; npar1<npars; npar1++) {
                if (cv[npar1] == VARRIED) {
                    fprintf(dev, "   %s", &symb[npar1][0]);
		}
            }
        }
        fprintf(dev, "\n");
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     18.                     G E T - R E Q U E S T                     */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

get_request()
{
 char thing;

 printf("> ");
 while ((thing = getchar()) == ' ');
 if (thing != '\n' && thing != '\r')  {
    getchar();  /* Throw away newline following command */
 }
return thing;
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     19.                     G E T - P A R - N A M E                   */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

get_par_name() {

    char garb,symbls[4];
/*    extern char toupper(); HOWITT */

    np = -1;
    while (np == -1) {
        if (user == NOVICE) {
            printf("\n\tTwo- or three-character name for parameter(or <CR> to quit): ");
        }
        else {
            printf("\n\tParameter: ");
        }

        symbls[0] = '\0';
        symbls[1] = '\0';
        symbls[2] = '\0';
        garb=getchar();
        if (garb != '\n') {
            symbls[0] = toUpper(garb);
            garb=getchar();
            if (garb != '\n') {
                symbls[1] = toUpper(garb);
                garb=getchar();
                if (garb != '\n') {
		    symbls[2] = toUpper(garb);
                    while (garb != '\n') {
                       garb=getchar();
                    }
                }
            }
        }

/*    Delete these lines when decodparam() is deleted */
	sym1 = symbls[0];
	sym2 = symbls[1];
	sym3 = symbls[2];

        if ((symbls[0] == '\0') || (symbls[0] == 'q')) {
            return(-2);         /* Request to quit */
        }
        if ((np = findnp(symbls)) == -1) {		/* 14. */
	    if (symbls[0] != '?') {
	        printf("\tERROR: '%s' is not a legal parameter\n",
		 symbls);
	    }
        }
    }
    return(np);
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     20.                      G E T - T I M E                          */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

get_time() {

        int nms;

	if (user == NOVICE) {
repett:     printf("\n\tTime in msec (limits are 0 to %d), or <CR> to quit: ",
              totdur);
        }
        else {
            printf("\tTime:  ");
        }
        nms = get_digits(stdin);		/* 22. Time in msec */
        if (nms < 0) {
            if (nms == -1) {
                return(-1);                     /* Request to quit */
            }
	    if (nms != -2) {
		printf("\t  ERROR in requested value\n");
	    }
            goto repett;
        }
        nms = nms / ms_frame;  /* Convert to number of frames */
	if (nms == nframes) {
	    nms--;		/* Assume user meant last possible frame */
	}
        else if (nms > nframes) {
            printf("\t  ERROR in requested value\n");
            goto repett;
        }
        return(nms);
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     21.                     G E T - V A L U E                         */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

get_value(arg) int arg; {

        if (user == NOVICE) {
gv1:        printf("\tValue (was %d, limits are %d to %d): ",
             arg, minval[np], maxval[np]);
        }
        else {
            printf("\tValue (was %d): ", arg);
        }
        val = get_digits(stdin);		/* 22. */
	if (val < -1) {
	    printf(
	 "\t  ERROR: Negative values are meaningless, retype time and value\n");
	    return(val);
	}
	val = checklimits();			/* 21. */
	if (val < 0) {
	    goto gv1;	/* checklimits sets to -2 if user doesn't override */
	}
	return(val);
}



checklimits() {

ch1:
        if (val > maxval[np]) {
            printf("\t  ERROR: %d is bigger than maxval[%s] = %d\n",
              val, &symb[np][0], maxval[np]);
            printf("\t  Override this suggested maximum [y] [n] ");
            command = get_request();		/* 18. */
            if (command == 'y') {
                maxval[np] = val;
		printf("\t\tmaxval[%s] is now %d\n", 
		 &symb[np][0], maxval[np]);
            }
            else {
		printf("\t  Please type requested value again\n");
		return(-2);
            }
        }
        if (val < minval[np]) {
	    if (val == -1) {
		val = getpval();		/* 15. */
		printf("\t  Use current value == %d\n", val);
		goto ch1;
	    }
            printf("\t  ERROR: %d is smaller than minval[%s] = %d\n",
              val, &symb[np][0], minval[np]);
            printf("\t  Override this suggested minimum [y] [n] ");
            command = get_request();
            if (command == 'y') {
                minval[np] = val;
		printf("\t\tminval[%s] is now %d\n", 
		  &symb[np][0], minval[np]);
            }
	    else {
		printf("\t  Please type requested value again\n");
		return(-2);
	    }
        }
        return(val);
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     22.                     G E T - D I G I T S                       */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

get_digits(dev) FILE *dev; {

        int dig,nn;
        char digitarray[9],c;

/*    Strip off leading white space */
        do {
            fscanf(dev, "%c", &c);
        } while ((c == ' ') || (c == '\t'));
        if (c == '\n') {
            return(-1);
        }

/*    Read digits and place in array digitarray[] */
        nn = 0;
        while ((c == '-') || ((c >= '0') && (c <= '9'))) {
            if (nn >= 8) {
                printf("\t  ERROR: Digit string too long, value set to 0\n");
                return(0);
            }
            digitarray[nn++] = c;
            fscanf(dev, "%c", &c);
        }
        if ((c != ' ') && (c != '\t') && (c != '\n')) {
            skip_line(stdin);               /* Gobble up CR */
            if (c == 'q') {
                return(-1);
            }
	    if (c == '?') {
		return(-2);
	    }
            printf("\t  ERROR: Alphabetic char '%c' in a digit string\n", c);
	    return(-2);
        }
        digitarray[nn] = '\0';

/*    Convert from ascii string to integer */
        dig = atoi(digitarray);
        return(dig);
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     23.               G E T - N O N W H I T E - C H A R               */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

get_nonwhite_char(dev) FILE *dev; {

        char c;

/*    Strip off leading whitespace */
        do {
            fscanf(dev, "%c", &c);
        } while ((c == ' ') || (c == '\t') || (c == '\n'));
        return(c);
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     24.                      S K I P - L I N E                        */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

skip_line(dev) FILE *dev; {

        char c;

        do {
            fscanf(dev, "%c", &c);
        } while (c != '\n');
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     25.                    M E R G E - S T R I N G S                  */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

mergestring(fname,sname,oname) char fname[],sname[],oname[]; {

        int nfirst;

loopn:  n = 0;
/*    See if name specified, if not, use 'default name' */
        if (fname[0] == '\0')    goto illnam;
        while ((n < 40) && (fname[n] != '\0')) {
            oname[n] = fname[n];
            n++;
        }
        nfirst = n;
        while ((n < 40) && (sname[n-nfirst] != '\0')) {
            oname[n] = sname[n-nfirst];
            n++;
        }
        if (n < 40) {
            oname[n] = '\0';
        }
        else {
illnam:	oname[39] = '\0';
	printf(
 "\n\tERROR: More than 40 chars in '%s' in mergestring(), sensyn.c\n",
              firstname);
	    exit(1);
        }
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     26.                    C O P Y - S T R I N G                      */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

copystring(istring,ostring) char istring[],ostring[]; {

        n = 0;
        do {
            ostring[n] = istring[n];
        } while (istring[n++] != '\0');
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     27.             H E L P - L I S T - A R G U M E N T S                */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

helpa() {

        printf("\n    Optional arguments for SenSyn:\n");
        printf("\t ?\tPrint this help menu\n");
   
/*   WILLIAMS:  removed reference to BATCH, all commands require CR        
        printf("\t-b\tBatch job, must press CR after each command\n");
*/
        printf("\t-n\tNovice user, verbose printout\n");
        printf("\t-vt100\tDisplay terminal is a vt100 (default)\n");
        printf("\t-vt125\tDisplay terminal is a vt125\n");
        printf("\tname\tFirst name of '.doc' file to be read\n");
        printf("\n");
}




/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*     28.             H E L P - A C T - O N - R E Q U E S T             */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

helpr() {

        printf("\n    Legal SenSyn commands:\n");
        printf("\tp\tPRINT set of synthesis parameter default values\n");
        printf("\tc\tCHANGE default value for a synthesis parameter\n");

/*   WILLIAMS:  changed menu to reflect new ENTER function
        printf("\td\tDRAW time-varying synthesis parameter values\n");
*/

        printf("\n\te\tENTER time varying synthesis parameter values\n");

/*   WILLIAMS:  changed menu, deleted references to graphics routines 
	printf("\tg\tGRAPH on LA-50 selected synthesis parameter time function\n");
	printf("\tG\tGRAPH on Laser printer all varied pars as a function of time\n");
*/
        printf("\n\ts\tSYNTHESIZE waveform file, save everything, quit");
        printf("\n\tS\tSAVE current parameters as .doc file (no synthesis), quit");
        printf("\n\tq\tQUIT program, save nothing\n");
        printf("\t?\tHELP, please list legal SenSyn commands\n");
        printf("\n");
}
